version: "3.8"

networks:
  internal:
    driver: overlay
    attachable: true
  traefik-public:
    external: true

volumes:
    db_data:
        driver: convoy
    php_data:
        driver: convoy

services:
  db:
    image: mariadb:latest
    deploy:
      replicas: 1
      restart_policy:
        condition: on-failure
        delay: 10s
        max_attempts: 10
        window: 15s
    environment:
        MYSQL_DATABASE: "laravel"
        MYSQL_ALLOW_EMPTY_PASSWORD: "yes"
        MYSQL_ROOT_PASSWORD: ""
    volumes:
      - db_data:/var/lib/mysql
    networks:
      - internal      
  php:
    image: ${CONTAINER_IMAGE}:latest
    deploy:
      replicas: 1
      restart_policy:
        condition: any
        delay: 10s
        max_attempts: 10
        window: 15s
      labels:
        - "traefik.enable=true"
        - traefik.docker.network=traefik-public
        - traefik.constraint-label=traefik-public
        - traefik.http.routers.${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-http.rule=Host(`${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${DOMAIN}`)
        - traefik.http.routers.${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-http.entrypoints=http
        - traefik.http.routers.${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-http.middlewares=https-redirect
        - traefik.http.routers.${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.rule=Host(`${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${DOMAIN}`)
        - traefik.http.routers.${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.entrypoints=https
        - traefik.http.routers.${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.tls=true
        - traefik.http.routers.${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}-https.tls.certresolver=le
        - traefik.http.services.${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}.loadbalancer.server.port=80
    depends_on:
      - db
    networks:
      - internal
      - traefik-public
